program mr2s; { Binder program, 15/5/99 am }
{$M $5000,0,$4000}
{$I-,R-,S-,V-,D+,L+}
{$IFNDEF FPC} {$G+} {$ENDIF}

{ -------------------[ history, see history.doc ]------------------------

  0.97  - rar, added brute force log file scanning
  0.98  - rar, bug fixing for vtc
  0.99  - rar, translated to English, Statistic, GuruHeadLine etc. FIXED
          WRONG COUNTING!
  1.03 - ah, fixed counter bug, adding semaphor file and changed the
          output style
  1.03p2 - rar, 04-aug-99, fixed wherey-1
  1.00  - rar, 12-sept-99, relase 1.00, fixed NT 4.00 NTFS problem
  1.01  - rar, 14-nov-99
  1.02  - rar, 11-april-2000, only signature update from RHBVS, lChk>0
          rar, 06-May-2000, released
  1.10  - rar, 04-June-2000, source code released, 600 new trojans,
          100 new viruses added. Check added if dir is empty
  1.11  - rar, 09-July-2000, new viruses, changed layout of the .OVR files
  1.12  - rar, 17-Aug-2000, new viruses, compiled with FPC 1.00
  1.13  - rar, 13-Sept-2000, new viruses, Win32 Stealth Live Bait test

  ----------------------------------------------------------------------- }


uses
{$IFDEF haak}
unzip, chkpak,
{$ENDIF}

{$IFDEF ROSE}
test286, syserr, netzwerk, dosv2,  {nt bug paramstr(0)}
{$ENDIF}
crt, dos;

const NAME  = 'Mr2S - Version 1.13 (Sept 2000)';
type str120 = string[120];

var report : str120;
    r, lock: text;
    lDirs, lChk, lFound : longint;
    var t, v : Byte;
    szHomeDir : String;         { whereis mr2s.exe? }

(* ************************************************************************ *)

Function GuruHeadLine(szWork: String) : String; { -=[ Text ]=- }

var szTmp : String;
    bW    : Byte;

begin

   bW := lo(windmax)-lo(windmin)-1;

   szTmp := '-[ '+szWork+' ]-';
   while length(szTmp) < bW
         do szTmp := szTmp + '';

   GuruHeadLine := szTmp;

end; { GuruHeadLine }

{ ------------------------------------------------------------------ }

function FileExists(FileName: String): Boolean;

var
  F: file;
begin
  {$I-}
  Assign(F, FileName);
  Reset(F);
  Close(F);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

{ ------------------------------------------------------------------ }

FUNCTION FORMAT(zahl : Longint): STRING;  { 1.12.93, rar }

VAR A,Hi             : STRING;
    T                : INTEGER;
    Rest             : Longint;

BEGIN

A:='';
IF Zahl<1000 THEN STR(zahl,a) ELSE
BEGIN
     WHILE Zahl>0 DO BEGIN
           Rest:=zahl-(zahl DIV 1000) * 1000;
           Zahl:=(zahl DIV 1000);
           STR(rest:3,Hi);
           IF (Hi[1]=' ') THEN Hi:=COPY(Hi,2,LENGTH(Hi)-1);
           IF (Hi[1]=' ') THEN Hi:=COPY(Hi,2,LENGTH(Hi)-1);
           T:=LENGTH(Hi);
           Hi:=COPY('000'+Hi,t+1,t+3);
           Hi:=COPY(Hi,1,3);

           A:=Hi+'.'+a;
     END;

     A:=COPY(a,1,LENGTH(a)-1); { Punkt am Ende entfernen }
     FOR T:=1 TO 3 DO BEGIN
         IF A[1]='0' THEN A:=COPY(a,2,LENGTH(a)-1);
     END;
END;  { if then }

Format:=a;

END; { Function }

{ --- [Writeln1 ] ------------------------------------------------------- }

procedure writeln1(szWhat: String); { 17.03.96, rar }

begin
     for t := 1 to length(szWhat) do
     begin
          v := byte(szWhat[t]);
          textcolor(7);
          if v < 48 then textcolor(3);
          if v in [91..96] then textcolor(3+8);
          if v > 122 then textcolor(1+8);
          if v = 254 then textcolor(white);
          (* if (chr(v) in ['A'..'Z']) then textcolor(11); *)
          write(szWhat[t]);
     end;
     textcolor(7);
     writeln;

end; { writeln1 }

procedure write1(szWas: String); { 17.03.96, rar }

begin
     for t := 1 to length(szWas) do
     begin
          v := byte(szWas[t]);
          textcolor(7);
          if v < 48 then textcolor(3);
          if v in [91..96] then textcolor(3+8);
          if v > 122 then textcolor(1+8);
          if v = 254 then textcolor(white);
          (* if (chr(v) in ['A'..'Z']) then textcolor(11); *)
          write(szWas[t]);
     end;
     textcolor(7);

end; { write1 }

{ --- [Statistik] --------------------------------------------------------- }

Procedure Statistik;  { 08.01.97, rar }

var s : String;

 Function sFormat(l : LongInt) : String;
 var s : String;

 begin { format }
   s := Format(l);
   while length(s) < 10 do s := ' '+s;
   sFormat := s;
 end; { format }

 begin { Statistik }
  clreol;
  writeln;
  writeln1(GuruHeadLine('Statistics'));
  writeln;
  writeln1(' Files checked ................................ '+sformat(lChk));
  if lChk>0 then str(lFound*100 / lChk:3:1,s) { fpc100 }
            else s := '0.0';
  writeln1(' Suspicious files ............................. '+sformat(lFound)+'  ('+s+'%)');
  writeln1(' Directories scanned .......................... '+sformat(lDirs));
  writeln;
  writeln1(GuruHeadLine('Scanning finished! Have a virus free time!'));

 end; { Statistik }



{ ####################   Routinen   ######################## }

function upstring(st : string) : string;
{Hinweis: Ohne Umlaute!!!}
var lauf1 : byte;
begin
  for lauf1:=1 to length(st) do st[lauf1]:=upcase(st[lauf1]);
  upstring:=st;
end;

{ ####################   Routinen   ######################## }

function TrimR(InpStr: string): string;       { fixed 21.04.97, rar }
{ strip trailing spaces from a String }
Var i : Byte;

Begin
   i := length(InpStr);
   While (i >= 1) and (InpStr[i] in [#9,' ',#255]) do
      i := i - 1;
   TrimR := Copy(InpStr,1,i)
End;

{ ------------------------------------------------------------------------ }
{ Call - Working Horse - Call all scanners, read the logs and process them }
{ ------------------------------------------------------------------------ }

procedure call(wo : str120);  { am, 15.05.99 }

var t,t2   : text;
    lauf   : integer;
    st,st2 : string;      { fixed, 17.05.99, rar }
    i, n   : integer;
    n1, n2 : Byte;
    szF1, szF2 : String;  { filename from the files1 & files2 }
    szV1, szV2 : String;  { Virus, if found }
    sr         : SearchRec;

begin

  findfirst(wo+'*.*', anyfile-directory-volumeid, sr);

  if (doserror = 18) then  { nothing to do! }
       exit;               { q'n'd speed up, rar 6.june.2000 }

  textcolor(lightgray);
  write(wo);  { \ Vernderte Verzeichnisausgabe (ah) }
  clreol;     { /                                    }

   swapvectors;
   exec(szHomeDir+'\mr2ssub1.exe',wo);
   exec(szHomeDir+'\mr2ssub2.exe',wo);
   swapvectors;

  {$I-}
  assign(t,'sub1.rep');                         { <---- $$$$$$$$$$$$$$$ }
  reset(t);

  for lauf:=1 to 2 do readln(t,st);   { tscan }

  readln(t, st);
  st := TrimR(st);

  if (st<>'') then
  repeat
    inc(lChk);

    n1 := Pos(' - ',st);
    if n1 = 0 { found? }
       then n1 := 255;

    szF1 := TrimR(copy(st, 1, n1));

    { brute force from beginning }
    assign(t2,'mr2ssub2.rep');
    reset(t2);
    repeat
          readln(t2, st2);
          n2 := Pos(' - ',st2);
          if n2 = 0 { found? }
             then n2 := 255;

          szF2 := TrimR(copy(st2, 1, n2));

    { -- debug -- }
    { writeln(r, 'FN: //',szf1,'//',szf2,'//'); }

    until eof(t2) or (szF1 = szF2);
    close(t2);

    { ok, now cat them together

      szF1 = szF2 = FileName
      n1, n2 - pos of Virus

    }

    szV1 := copy(st, n1+3, 255);
    szV2 := copy(st2, n2+3, 255);


    { -- debug -- }
    { writeln(r, 'VN: //',szv1,'//',szv2,'//'); }

    st := szF1;

    if szV2 <> '' then
    begin
         if szV1 = '' then st := st + ' - ' + szV2
                      else st := st + ' - ' + szV1 + ' ('+szV2+')';
    end
       else
         if szV1 <> '' then st := st + ' - ' + szV1;

 { -------------------------------------------------------------- }

    if pos(' - ',st)<>0 then
    begin
      textcolor(red);

      { --- VSP/RHBVS don`t uses "Infektion" --- }
      if (Pos('Infektion: ', st) = 0) AND (Pos('Warnung', st) = 0)
         AND (Pos('Fehler', st) = 0) then
      begin
         n := Pos(' - ', st);
         st := copy(st, 1, n+2)+'Infektion: '+copy(st,n+3,255);
      end;

      n := Pos('Infektion:', st);
      if n > 1 then begin
                         inc(lFound);
                         st[n+4] := 'c';  { Infection }
                    end;
      writeln(st);                   { Ausgabe falls Virus gefunden }
    end else textcolor(lightgray);


    if report<>'' then writeln(r,st);

    readln(t, st);

  until (st='') or eof(t);

  close(t);
  { ------------------------ aufrumen -------------------- }
  erase(t2);  if ioresult <> 0 then { mr2s_rs: sux };
  erase(t);

{$I+}

  i:=ioresult;
  if i<>0 then begin
    textcolor(lightred);
    writeln(#7'!!! Fatal: I/O-Error !!!'#7);
    textcolor(lightgray);
  end;
end;

{ ------------------------------------------------------------------ }

procedure suchedateien(p : str120);
var gg : searchrec;
begin
  inc(lDirs);
  if p[length(p)]<>'\' then p:=upstring(p)+'\' else p:=upstring(p);
  findfirst(p+'*.*',anyfile,gg);
  while (doserror=0) do
  begin
    with gg do begin
      if (name[1]<>#46) and ((attr and volumeid)=0) then
      begin
        if attr and directory=0 then
        begin

          { skip files! }

        end
      else
        begin
          {$ifdef haak}
          chkpak(p+name+#92);
          {$endif}
          call(p+name+#92);
          suchedateien(p+name+#92); {rekursiv}
        end;
      end;
    end;
    findnext(gg);
  end;
end;

{ ------------------------------------------------------------------ }

procedure scanne(p : str120);
begin
  p:=upstring(p);
  {writeln('Directory to scan: '+p+#13#10);}

  p:=upstring(p);
  if p[length(p)]<>'\' then p:=p+'\';
  call(p);
  suchedateien(p);

  gotoxy(1,wherey);
  clreol;
end;

{ ------------------------------------------------------------------ }

var path : str120;
    antwort:char;

begin
  lDirs :=0;
  lChk:=0;
  lFound:=0;

  writeln;
  writeln1(GuruHeadLine('Mr. Double Scan - '+NAME));
  writeln ('(c) 1989-2000 Andreas Haak, Andreas Marx & Ralph Roth - ALL RIGHTS RESERVED!');

  { deletefile('lock.dat'); }
  if fileexists('lock.dat') then
  begin
      writeln;
      writeln1('A lock file was found. Do NOT start Mr2S in several tasks!');
      writeln1('If you continue and Mr2S is still active, Mr2S will crash!');
      write1('Do you want to continue (y/N) ?');
      antwort:=readkey;
      writeln1(antwort);
      if upcase(antwort)<>'Y' then halt(1);
  end;
  assign(lock,'lock.dat');
  rewrite(lock);
  writeln(lock,'MrDoubleScan - LockFile! Please do not delete!');
  close(lock);

  GetDir(0, szHomeDir);

  swapvectors;
  exec(szHomeDir+'\mr2s_chk.ovr','');
  swapvectors;
  writeln;

  if paramcount=0 then
  begin
    writeln1(GuruHeadLine('Usage'));
    writeln ('mr2s   drive:\[path2scan]   [name_of_logfile]');
    erase(lock);
    halt(1);
  end;
  path:=paramstr(1);
  if paramcount=2 then report:=paramstr(2) else report:='';

  if report<>'' then begin
    assign(r,report);
    rewrite(r);

    writeln(r);
    writeln(r,'--- ',Name,' --- Report --- START ---');
    writeln(r);
  end;

  writeln1(GuruHeadLine(Path));
  scanne(path);

  Statistik;

  if report<>'' then
  begin
    writeln(r);
    writeln(r,'--- ',name,' --- Report --- END ---');
    writeln(r);

    writeln(r,'Directories scanned: ',lDirs);
    if lChk <> 0 then
       writeln(r,'Files scanned: '+Format(lChk)+', suspious: '+Format(lFound)
           +' (',(lFound*100 / lChk):2:2,'%)');   { fpc100 }
    writeln(r,#13#10);

    close(r);
  end;
erase(lock);

chdir(szHomeDir);

end.
