{*****************************************************************************}
{*                                                                           *}
{*           Ŀ                              *}
{*            ROSE Softwareentwicklung                                    *}
{*            Dipl.-Ing. (FH) Ralph Roth                                  *}
{*            Finkenweg 24                                                *}
{*                                                                        *}
{*            D 78658 Zimmern o. R.                                       *}
{*                                                                        *}
{*                                        *}
{*                                          *}
{*                                                                           *}
{* Part of the Mr2S package: MR2S_CHK, checks for viruses in memory          *}
{*                                                                           *}
{*****************************************************************************}

{$M 16384,0,150000}
{$A+,B+,D+,E-,G+,L+,N-,V-,I-,R-,S-}

program VirusKiller;

uses  test286, tpdos, dosv2,    { G+/286 check nicht erforderlich }
      crt, dos, avrmem, avr_poly, killer2,
      avrmini, famr, famcrypt, killer1,
      famvcl, drvtypes, checksum,
      utils, strings, constant, killer,
      netzwerk;                 { netzwerk nicht erforderlich! }


{ ------[MAIN]--------------------------------------------------------- }

begin

  avrmem_language := English;                           (* Deutsch! *)
  if QuickMemScan(FALSE) then halt(1);                  (* vIRUS *)
  if HLL_LiveGoat then halt(2);				{ Stealth virus found! }
  if Win_LiveGoat then halt(3);				{ Stealth virus found! }

  CheckFilesThere;                                      (* halt 1, if err *)
  halt(0);                                              (* -ok- *)

end.
